﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Windows.Threading;

namespace XamGridWith_RealTimeUpdate
{
    public partial class MainWindow : Window
    {
        private Random _random = new Random();
        private DispatcherTimer _timer = new DispatcherTimer();

        public MainWindow()
        {
            InitializeComponent();
            StartTimer();
        }

        // Set up initial value
        private void XamGrid1_Loaded(object sender, RoutedEventArgs e)
        {
            SetValues();
        }

        public void StartTimer()
        {
            if (!_timer.IsEnabled)
            {
                // Set up time interval
                _timer.Interval = new TimeSpan(0, 0, 0, 2);

                // When time interval has elapsed, re-bind the Grid
                _timer.Tick += new EventHandler(_timer_Tick);
                _timer.Start();
            }
        }

        void _timer_Tick(object sender, EventArgs e)
        {
            SetValues();
        }

        private void SetValues()
        {
            List<Entity> list = new List<Entity>();
            list.Add(new Entity(1, "Id1", "Label1"));
            list.Add(new Entity(1, "Id2", "Label2"));
            list.Add(new Entity(1, "Id3", "Label3"));
            for (int i = 0; i < 2000; i++)
            {
                list[0].Children.Add(new Entity(_random.Next(2000), "Id1", "Label1"));
            }
            this.XamGrid1.DataSource = list;
            this.XamGrid1.Records[0].IsExpanded = true;
        }
    }

    public class Entity
    {
        public int Property1 { get; set; }
        public string Property2 { get; set; }
        public string Property3 { get; set; }
        public Entities Children { get { return this.children; } }
        private Entities children = new Entities();

        public Entity() { }

        public Entity(int p1, string p2, string p3)
        {
            this.Property1 = p1;
            this.Property2 = p2;
            this.Property3 = p3;
        }
    }

    public class Entities : List<Entity>
    {
        public Entities()
        {
            List<Entity> list = new List<Entity>();
        }
    }
}
